#!/usr/bin/env python3

import os
import sys

runId = sys.argv[1]
cbmrootConfigPath = "/home/martin/cbm/cbmroot/build/config.sh"
macroDir = "/home/martin/cbm/cbmroot/macro/rich/run"

# Settings
nEvents = 100
urqmdFile  = "default10gev"
plutoFile  = ""
nElectrons = 5
nPositrons = 5
engine     = 0 # 0: geant3 1: geant4

geoSetup   = "sis100_electron"
randomSeed = 0

eventRate = -1e7
tsLength = -1
eventBuilder = "Ideal"
useMC = 1
monitor = 0
resultDir = ""
# resultDir = "results_recoqa_" + runId + "/"

# Files
dataDir  = "/home/martin/cbm/cbmroot/macro/rich/run/data/"
fileName = "test"
traFile  = dataDir + fileName + runId + ".tra.root"
parFile  = dataDir + fileName + runId + ".par.root"
geoFile  = dataDir + fileName + runId + ".geo.root"
digiFile = dataDir + fileName + runId + ".digi.root"
recoFile = dataDir + fileName + runId + ".reco.root"
qaFile   = dataDir + fileName + runId + ".qa.root"
# traFile = "/home/martin/cbm/cbmroot/macro/rich/run/data/test.tra.root"
# parFile = "/home/martin/cbm/cbmroot/macro/rich/run/data/test.par.root"
# digiFile = "/home/martin/cbm/cbmroot/macro/rich/run/data/test.digi.root"


traCmd=('root -l -b -q {}/run_transport.C\(\\"{}\\",\\"{}\\",\\"{}\\",\\"{}\\",{},{},{},\\"{}\\",\\"{}\\",{},{}\)').format(macroDir, urqmdFile, traFile, parFile, geoFile, nEvents, nElectrons, nPositrons, plutoFile, geoSetup, engine, randomSeed)
digiCmd=('root -l -b -q {}/run_digi.C\(\\"{}\\",\\"{}\\",\\"{}\\",{},{},{},{},{}\)').format(macroDir, traFile, parFile, digiFile, nEvents, eventRate, tsLength, randomSeed, monitor)
recoCmd=('root -l -b -q {}/run_reco.C\(\\"{}\\",\\"{}\\",\\"{}\\",\\"{}\\",{},\\"{}\\",\\"{}\\",{},{}\)').format(macroDir, traFile, parFile, digiFile, recoFile, nEvents, geoSetup, eventBuilder, useMC, monitor)
qaCmd=('root -l -b -q {}/run_qa.C\(\\"{}\\",\\"{}\\",\\"{}\\",\\"{}\\",\\"{}\\",{},\\"{}\\",\\"{}\\",{}\)').format(macroDir, traFile, parFile, digiFile, recoFile, qaFile, nEvents, geoSetup, resultDir, monitor)

os.system((". {} -a ; {}").format(cbmrootConfigPath, traCmd))
os.system((". {} -a ; {}").format(cbmrootConfigPath, digiCmd))
os.system((". {} -a ; {}").format(cbmrootConfigPath, recoCmd))
os.system((". {} -a ; {}").format(cbmrootConfigPath, qaCmd))
